require 'middleclass'
require 'middleclass-commons'
require 'LUBE'
require 'Tserial'

function love.load()
	port = 1234 
	server = lube.udpServer()
	server:listen(port)
	server.handshake = "handshake"
	server:setPing(true, 6, "ping\n")
	server.callbacks.recv = function(d, id) recv(d, id) end
	server.callbacks.connect = function(id) connect(id) end
	server.callbacks.disconnect = function(id) disconnect(id) end
	print('Server started on port: ' .. tostring(port))
	iplist = {}
	userlist = {}
	xlist = {}
	ylist = {}
end

function connect(clientId)
	print('Client connected: ' .. tostring(clientId))
	iplist[#iplist+1] = clientId
	server:send(#iplist, clientId)
end

function disconnect(clientId)
	print('Client disconnected ' .. tostring(clientId))
	for i = 1, #iplist, 1 do
		if iplist[i] == clientId then
			iplist[i] = nil
			xlist[i] = nil
			ylist[i] = nil
			break
		end
	end
end

function recv(data, clientId)
	print('Client data received from: ' .. tostring(clientId) .. ' containing: ' .. data)

	datastream = Tserial.unpack(data, true)

	if datastream[1] == 'x' then
		for i = 1, #iplist, 1 do
			if iplist[i] == clientId then
				xlist[i] = datastream[2]
			end
		end
	
	elseif datastream[1] == 'y' then
		for i = 1, #iplist, 1 do
			if iplist[i] == clientId then
				ylist[i] = datastream[2]
			end
		end
	end
end

function love.update(dt)
	server:update(dt)
	server:send('send')
	print(iplist[1], xlist[1], '', iplist[2], xlist[2])
end
